package jesse.keeblarcraft.AttributeMgr.AttributeNodes.FactionNodes;

import java.util.HashMap;
import java.util.List;

import jesse.keeblarcraft.AttributeMgr.AttributeNodes.AbstractNode;
import jesse.keeblarcraft.FactionMgr.Callbacks.PlayerInBaseCallback;
import net.minecraft.entity.effect.StatusEffectInstance;
import net.minecraft.entity.effect.StatusEffects;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.util.ActionResult;

public class FactionBeacon extends AbstractNode {
    private int beaconStrength = 1; // Increases with faction power; 1 is default
    private float absorptionAmnt = 0.2f * beaconStrength;
    @Override
    public String GetNodeTitle() {
        return "faction_beacon";
    }

    @Override
    public String GetNodeDescription() {
        return "This is a great unlockable for any faction to have and is leveled up with higher faction power. Gives beacon-like abilities + more!";
    }

    @Override
    public HashMap<String, List<String>> GetDetails() {
        HashMap<String, List<String>> ret = new HashMap<String, List<String>>();
        ret.put("Faction Beacon", List.of("Grants a ton of beacon-like effects on faction members inside the radius of the faction block"));
        return ret;
    }

    private void ApplyEffects(ServerPlayerEntity player) {
        // player.setAbsorptionAmount(absorptionAmnt);
        // Duration is in ticks
        StatusEffectInstance conduit = new StatusEffectInstance(StatusEffects.CONDUIT_POWER, 40, 0, true,true, true);
        StatusEffectInstance regen = new StatusEffectInstance(StatusEffects.REGENERATION, 40, 0, true, true, true);
        StatusEffectInstance hero = new StatusEffectInstance(StatusEffects.HERO_OF_THE_VILLAGE, 40, 0, true, true, true);
        StatusEffectInstance fire = new StatusEffectInstance(StatusEffects.FIRE_RESISTANCE, 40, 0, true, true, true);

        player.addStatusEffect(conduit);
        player.addStatusEffect(regen);
        player.addStatusEffect(hero);
        player.addStatusEffect(fire);
    }

    @Override
    public void RegisterCallbacks() {
        System.out.println("REGISTER CALLBACKS FOR FACTION BEACON CALLED");
        PlayerInBaseCallback.EVENT.register((player, world, power, factionTier) -> {
            // Make sure player can fly while inside the border. We don't ever want to run this more than once!
            // player.sendMessage(Text.of("Applying effects"));
            ApplyEffects((ServerPlayerEntity) player);
            return ActionResult.PASS;
        });
    }

}
